package org.nl.acs.labeling_template.service;

import org.nl.acs.common.base.PageInfo;
import org.nl.acs.common.base.CommonService;
import org.nl.acs.labeling_template.domain.LabelingTemplate;
import org.nl.acs.labeling_template.service.dto.LabelingTemplateDto;
import org.nl.acs.labeling_template.service.dto.LabelingTemplateQueryParam;
import org.springframework.data.domain.Pageable;
import java.util.List;
import java.util.Set;

/**
* @author jiaolm
* @date 2023-05-09
*/
public interface LabelingTemplateService extends CommonService<LabelingTemplate>  {

    static final String CACHE_KEY = "labelingTemplate";

    /**
    * 查询数据分页
    * @param query 条件
    * @param pageable 分页参数
    * @return PageInfo<LabelingTemplateDto>
    */
    PageInfo<LabelingTemplateDto> queryAll(LabelingTemplateQueryParam query, Pageable pageable);

    /**
    * 查询所有数据不分页
    * @param query 条件参数
    * @return List<LabelingTemplateDto>
    */
    List<LabelingTemplateDto> queryAll(LabelingTemplateQueryParam query);

    LabelingTemplate getById(String id);
    LabelingTemplateDto findById(String id);

    /**
     * 插入一条新数据。
     */
    int insert(LabelingTemplateDto resources);
    int updateById(LabelingTemplateDto resources);
    int removeById(String id);
    int removeByIds(Set<String> ids);

    /**
    * 导出数据
    * @param all 待导出的数据
    * @param response /
    * @throws IOException /
    */
    // void download(List<LabelingTemplateDto> all, HttpServletResponse response) throws IOException;
}
